/* IIS-NTLM: Quick dirty hack to encrypt NTLM authentication response based 
   on 8-byte challenge (just didnt want to re-implement in perl *yet*)

   I snagged stuff out of several other peoples' code to hobble this together
   thanks to all! read util.c to see if you were one of them :)
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>


int
main(int argc, char **argv) {

   int i;
   char chal[8], passw[16], hash1[128], hash2[128];
   if(argc < 3) {
    fprintf(stderr,"usage: %s <8b-hex-challenge> <password>\n", argv[0]); 
    exit(1);
   }
   hex_decode(argv[1],chal,8);
   strncpy(passw,argv[2],16);


   SMBencrypt(passw, chal, hash1);   /* LM Hash response */
   SMBNTencrypt(passw, chal, hash2); /* NT Hash response */

/* 
   Nulls sometimes appear in the actual response, fwrite to avoid 
   premature termination.
*/

   printf("%s:%s:", passw, argv[1]);
   printhex(hash1, 24);
   printf(":");
   printhex(hash2, 24);
   printf("\n");

   return(0);
}




